import os
import string

#dont uncomment this, this is what generates the text file
'''
output = dict()
chars = []
exclusions = {' ','!', '-', '(', ')', '[', ']', ',','.',"'", '@', "+", '_'}
for root, folder, files, in os.walk(os.getcwd()):
    if folder != []:
        for item in folder:
            for char in item:
                if char not in string.ascii_letters and char not in exclusions and char not in string.digits:
                    if item not in output:
                        output[item] = None
for item in output:
    s = ''
    for char in item:
        if char in string.ascii_letters or char in exclusions or char in string.digits:
            s += char
        elif char in {'☆', '♂', '・', '★', '♪'}:
            s += ' '
    output[item] = s
    print(s)
with open('song_titles.txt', 'w') as text_file:
    for key, value in output.items():
        text_file.write(f'{key},{value}\n')
'''

def replace_a_line(file_path, old_line_content, new_line_content):
    try:
        with open(file_path, 'r', encoding='utf-8-sig') as file:
            lines = file.readlines()
        line_found = False
        for i, line in enumerate(lines):
            if old_line_content in line:
                lines[i] = new_line_content + '\n'
                line_found = True
                break
        if not line_found:
            print(f"Line with content '{old_line_content}' not found in the file.")
            return
        with open(file_path, 'w', encoding='utf-8-sig') as file:
            file.writelines(lines)
        print("Line has been replaced successfully.")
    except FileNotFoundError:
        print(f"Error: The file '{file_path}' was not found.")
    except Exception as e:
        print(f"An unexpected error occurred: {e}")

def load_title_mappings(mapping_file):
    title_mappings = {}
    with open(mapping_file, 'r') as file:
        for line in file:
            old_title, new_title = line.strip().split(',', 1)
            title_mappings[old_title] = new_title
    return title_mappings

def replace_titles_in_file(file_path, title_mappings):
    with open(file_path, 'r', encoding='utf-8-sig') as file:
        lines = file.readlines()

    new_lines = []
    modified = False
    for line in lines:
        if 'WAVE:' in line:
            for old_title, new_title in title_mappings.items():
                if old_title in line:
                    line = line.replace(old_title, new_title)
                    modified = True
        new_lines.append(line)

    if modified:
        with open(file_path, 'w', encoding='utf-8-sig') as file:
            file.writelines(new_lines)
        print(f'Processed file: {file_path}')

def process_directory(directory, title_mappings):
    for root, _, files in os.walk(directory):
        for file in files:
            if file.endswith('.tja'):
                file_path = os.path.join(root, file)
                replace_titles_in_file(file_path, title_mappings)

def rename_files_in_directory(directory, title_mappings):
    for root, _, files in os.walk(directory):
        for file in files:
            file_path = os.path.join(root, file)
            # Check each old title and see if it matches part of the filename
            for old_title, new_title in title_mappings.items():
                if old_title in file:
                    new_file_name = file.replace(old_title, new_title)
                    new_file_path = os.path.join(root, new_file_name)
                    # Rename the file
                    if file.endswith('.score.ini'):
                        os.rename(file_path, new_file_path)
                        print(f'Renamed file: {file_path} to {new_file_path}')
                    # No need to check further for this file
                    break

title_mappings = load_title_mappings('song_titles.txt')
#process_directory(os.getcwd(), title_mappings)
rename_files_in_directory(os.getcwd(), title_mappings)
